#include "civetweb-ds-log.h"

#include <ds/log.h>
#include <stdarg.h>

static ds::LogChannel dsLogChannel("civetweb");

extern "C" {

void civetwebDebugTrace(const char *func, unsigned line, const char *fmt, ...) {
  auto severity = ds::LogSeverity::DEBUG;
  if (dsLogChannel.shouldLog(severity)) {
    va_list args;
    va_start(args, fmt);
    std::array<char, 256> message;
    vsnprintf(message.data(), message.size(), fmt, args);
    va_end(args);
    dsLogChannel.log(severity, ds::str(message.data(), " ", func, ":", line));
  }
}
}
