#pragma once

#include <memory>

namespace ds {

// std::make_unique from c++14
template <typename T, typename... Args>
std::unique_ptr<T> make_unique(Args&&... args) {
  return std::unique_ptr<T>(new T(std::forward<Args>(args)...));
}

} // namespace ds
