/*
    Copyright (c) 2018 digitalSTROM.org, Zurich, Switzerland

    This file is part of digitalSTROM Server.

    digitalSTROM Server is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    digitalSTROM Server is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with digitalSTROM Server. If not, see <http://www.gnu.org/licenses/>.
*/

#pragma once

#include <ds/json.h>
#include <ds/reflect.h>
#include "http_client.h"

namespace dss {

/// Mockable client calling dsa http interface
class DsaHttpClient {
public:
  virtual ~DsaHttpClient() {}

  /// Invoke ds request, return data payload as json.
  /// Throws on any failure.
  virtual ds::JsonFragment request(HttpRequest&&) = 0;
};

// Dsa client connecting to "http://localhost:8087" base url
std::unique_ptr<DsaHttpClient> makeDsaHttpClient();

} // namespace dss
