/*
    Copyright (c) 2018 digitalSTROM.org, Zurich, Switzerland

    Author: Grzegorz Krajewski

    This file is part of digitalSTROM Server.

    digitalSTROM Server is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    digitalSTROM Server is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with digitalSTROM Server. If not, see <http://www.gnu.org/licenses/>.

*/

#ifndef ACTION_H
#define ACTION_H

#include <string>
#include <functional>
#include <boost/locale/message.hpp>

#include "sceneaccess.h"
#include "modelconst.h"
#include "deviceinterface.h"

namespace dss {

  class Group;
  class Cluster;
  class Apartment;

  template <typename T>
  class Action {
  public:
    std::string id;
    boost::locale::message title;
    std::function<void(T&, callOrigin_t, SceneAccessCategory)> invoke;
    ApplicationType type;
  }; // Action

} // namespace dss

#endif /* ACTION_H */
