/*
    Copyright (c) 2018 digitalSTROM AG, Zurich, Switzerland

    This file is part of digitalSTROM Server.

    digitalSTROM Server is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    digitalSTROM Server is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with digitalSTROM Server. If not, see <http://www.gnu.org/licenses/>.
*/

#pragma once

///
/// Generic vdc declarations common for vdcs and backendVdcs
///

#include <ds/reflect.h>
#include <string>

namespace dss {

struct VdcCapabilitiesSpec {
  bool metering;
  bool identification;
  bool dynamicDefinitions;
};

struct VdcSpec {
  std::string dSUID;
  std::string model;
  std::string modelVersion;
  std::string modelUID;
  std::string hardwareVersion;
  std::string hardwareGuid;
  std::string hardwareModelGuid;
  std::string vendorName;
  std::string vendorGuid;
  std::string oemGuid;
  std::string oemModelGuid;
  std::string configURL;
  std::string name;
  std::string displayId;
  std::string implementationId;
  VdcCapabilitiesSpec capabilities;
  bool authorized;
};

} // namespace dss

DS_REFLECT(dss::VdcCapabilitiesSpec, (metering)(identification)(dynamicDefinitions));
DS_REFLECT(dss::VdcSpec,
    (dSUID)(model)(modelVersion)(modelUID)(hardwareVersion)(hardwareGuid)(hardwareModelGuid)(vendorName)(vendorGuid)(
        oemGuid)(oemModelGuid)(configURL)(name)(displayId)(implementationId)(capabilities)(authorized));
