// Generated by Cap'n Proto compiler, DO NOT EDIT
// source: device-config.capnp

#include "device-config.capnp.dss.h"
#include <boost/foreach.hpp>
#include <json-c/json.h>
#include <ds/enum.h>
#include <ds/log.h>
#include "web/webrequests.h"


// =======================================================================================

namespace dss {
namespace view {
namespace deviceConfig {
namespace dssCapnp {

ds::Enum<Application> dsEnum(Application) {
  static constexpr std::pair<Application, const char*> x[] = {
      {Application::NONE, "none"}, {Application::LIGHTS, "lights"}, {Application::BLINDS, "blinds"},
      {Application::HEATING, "heating"}, {Application::AUDIO, "audio"}, {Application::VIDEO, "video"},
      {Application::JOKER, "joker"}, {Application::COOLING, "cooling"}, {Application::VENTILATION, "ventilation"},
      {Application::WINDOW, "window"}, {Application::RECIRCULATION, "recirculation"},
      {Application::TEMPERATURE_CONTROL, "temperatureControl"},
      {Application::APARTMENT_VENTILATION, "apartmentVentilation"},
      {Application::APARTMENT_RECIRCULATION, "apartmentRecirculation"}, {Application::SECURITY, "security"},
      {Application::ACCESS, "access"}, {Application::AWNINGS, "awnings"},
  };
  return {gsl::make_span(x), "Application"};
}
std::ostream& operator<<(std::ostream& ostream, Application x) { return ds::ostream(ostream, x); }

void Cluster::addFieldsToJson(::dss::JSONWriter& json) const {
  json.add("id");
  json.add(id);
  json.add("application");
  json.add(ds::tryFromEnum<const char *>(application).value_or("none"));
  json.add("title");
  json.add(title);
}

void Cluster::setJson(::json_object* object) {
  DS_REQUIRE(json_object_is_type(object, json_type_object), "Expecting json object.");
  json_object_object_foreach(object, dsCapnpKey, dsCapnpValue) {
  if (strcmp(dsCapnpKey, "id") == 0) {
    DS_CONTEXT("/id");
    DS_REQUIRE(json_object_is_type(dsCapnpValue, json_type_double) ||
        json_object_is_type(dsCapnpValue, json_type_int), "Expecting json number");
    id = json_object_get_int64(dsCapnpValue);
  }
  if (strcmp(dsCapnpKey, "application") == 0) {
    DS_CONTEXT("/application");
    DS_REQUIRE(json_object_is_type(dsCapnpValue, json_type_string), "Expecting json string");
    auto&& _dsCapnpStringValue = json_object_get_string(dsCapnpValue);
    if (auto x = ds::tryToEnum< ::dss::view::deviceConfig::dssCapnp::Application>(_dsCapnpStringValue)) {
      application = *x;
    } else {
      DS_FAIL_REQUIRE("Unrecognized enum value", _dsCapnpStringValue);
    }
  }
  if (strcmp(dsCapnpKey, "title") == 0) {
    DS_CONTEXT("/title");
    DS_REQUIRE(json_object_is_type(dsCapnpValue, json_type_string), "Expecting json string");
    title = json_object_get_string(dsCapnpValue);
  }
  }
}

Cluster Cluster::fromJson(const char* text) {
  struct json_tokener* tok = json_tokener_new();
  DS_DEFER(json_tokener_free(tok));

  json_object* object = json_tokener_parse_ex(tok, text, -1);
  DS_REQUIRE(object, json_tokener_error_desc(json_tokener_get_error(tok)));
  DS_DEFER(json_object_put(object));

  Cluster out;
  out.setJson(object);
  return out;
}

std::ostream& operator<<(std::ostream& ostream, const Cluster& x) {
  JSONWriter json(JSONWriter::jsonNoneResult);
  x.addFieldsToJson(json);
  return ostream << json.successJSON();
}

ds::Enum<Args_InputTypeMode> dsEnum(Args_InputTypeMode) {
  static constexpr std::pair<Args_InputTypeMode, const char *> x[] = {
    {Args_InputTypeMode::HIDDEN_PUSH_BUTTON, "hiddenPushButton"},
    {Args_InputTypeMode::SHOWN_PUSH_BUTTON_AND_SENSOR, "shownPushButtonAndSensor"},
  };
  return {gsl::make_span(x), "Args_InputTypeMode"};
}
std::ostream& operator<<(std::ostream& ostream, Args_InputTypeMode x) { return ds::ostream(ostream, x); }

void Args::addFieldsToJson(::dss::JSONWriter& json) const {
  json.add("memberOfClusters");
  json.startArray();
  BOOST_FOREACH(auto&& _x, memberOfClusters) {
    json.startObject(); _x.addFieldsToJson(json); json.endObject();
  }
  json.endArray();
  json.add("showApplication");
  json.add(showApplication);
  json.add("showTemperatureControlApplication");
  json.add(showTemperatureControlApplication);
  json.add("showApartmentApplications");
  json.add(showApartmentApplications);
  json.add("showInput");
  json.add(showInput);
  json.add("inputTypeMode");
  json.add(ds::tryFromEnum<const char *>(inputTypeMode).value_or("hiddenPushButton"));
  json.add("showPushButtonApplication");
  json.add(showPushButtonApplication);
  json.add("showPushButtonDeviceMode");
  json.add(showPushButtonDeviceMode);
  json.add("showPushButtonDisabledMode");
  json.add(showPushButtonDisabledMode);
  json.add("showPushButtonMode");
  json.add(showPushButtonMode);
  json.add("showOutput");
  json.add(showOutput);
  json.add("showOutputAttachedDevice");
  json.add(showOutputAttachedDevice);
}

void Args::setJson(::json_object* object) {
  DS_REQUIRE(json_object_is_type(object, json_type_object), "Expecting json object.");
  json_object_object_foreach(object, dsCapnpKey, dsCapnpValue) {
  if (strcmp(dsCapnpKey, "showApplication") == 0) {
    DS_CONTEXT("/showApplication");
    DS_REQUIRE(json_object_is_type(dsCapnpValue, json_type_boolean), "Expecting json boolean");
    showApplication = json_object_get_boolean(dsCapnpValue);
  }
  if (strcmp(dsCapnpKey, "showTemperatureControlApplication") == 0) {
    DS_CONTEXT("/showTemperatureControlApplication");
    DS_REQUIRE(json_object_is_type(dsCapnpValue, json_type_boolean), "Expecting json boolean");
    showTemperatureControlApplication = json_object_get_boolean(dsCapnpValue);
  }
  if (strcmp(dsCapnpKey, "showApartmentApplications") == 0) {
    DS_CONTEXT("/showApartmentApplications");
    DS_REQUIRE(json_object_is_type(dsCapnpValue, json_type_boolean), "Expecting json boolean");
    showApartmentApplications = json_object_get_boolean(dsCapnpValue);
  }
  if (strcmp(dsCapnpKey, "showInput") == 0) {
    DS_CONTEXT("/showInput");
    DS_REQUIRE(json_object_is_type(dsCapnpValue, json_type_boolean), "Expecting json boolean");
    showInput = json_object_get_boolean(dsCapnpValue);
  }
  if (strcmp(dsCapnpKey, "inputTypeMode") == 0) {
    DS_CONTEXT("/inputTypeMode");
    DS_REQUIRE(json_object_is_type(dsCapnpValue, json_type_string), "Expecting json string");
    auto&& _dsCapnpStringValue = json_object_get_string(dsCapnpValue);
    if (auto x = ds::tryToEnum< ::dss::view::deviceConfig::dssCapnp::Args::InputTypeMode>(_dsCapnpStringValue)) {
      inputTypeMode = *x;
    } else {
      DS_FAIL_REQUIRE("Unrecognized enum value", _dsCapnpStringValue);
    }
  }
  if (strcmp(dsCapnpKey, "showPushButtonApplication") == 0) {
    DS_CONTEXT("/showPushButtonApplication");
    DS_REQUIRE(json_object_is_type(dsCapnpValue, json_type_boolean), "Expecting json boolean");
    showPushButtonApplication = json_object_get_boolean(dsCapnpValue);
  }
  if (strcmp(dsCapnpKey, "showPushButtonDeviceMode") == 0) {
    DS_CONTEXT("/showPushButtonDeviceMode");
    DS_REQUIRE(json_object_is_type(dsCapnpValue, json_type_boolean), "Expecting json boolean");
    showPushButtonDeviceMode = json_object_get_boolean(dsCapnpValue);
  }
  if (strcmp(dsCapnpKey, "showPushButtonDisabledMode") == 0) {
    DS_CONTEXT("/showPushButtonDisabledMode");
    DS_REQUIRE(json_object_is_type(dsCapnpValue, json_type_boolean), "Expecting json boolean");
    showPushButtonDisabledMode = json_object_get_boolean(dsCapnpValue);
  }
  if (strcmp(dsCapnpKey, "showPushButtonMode") == 0) {
    DS_CONTEXT("/showPushButtonMode");
    DS_REQUIRE(json_object_is_type(dsCapnpValue, json_type_boolean), "Expecting json boolean");
    showPushButtonMode = json_object_get_boolean(dsCapnpValue);
  }
  if (strcmp(dsCapnpKey, "showOutput") == 0) {
    DS_CONTEXT("/showOutput");
    DS_REQUIRE(json_object_is_type(dsCapnpValue, json_type_boolean), "Expecting json boolean");
    showOutput = json_object_get_boolean(dsCapnpValue);
  }
  if (strcmp(dsCapnpKey, "showOutputAttachedDevice") == 0) {
    DS_CONTEXT("/showOutputAttachedDevice");
    DS_REQUIRE(json_object_is_type(dsCapnpValue, json_type_boolean), "Expecting json boolean");
    showOutputAttachedDevice = json_object_get_boolean(dsCapnpValue);
  }
  }
}

Args Args::fromJson(const char* text) {
  struct json_tokener* tok = json_tokener_new();
  DS_DEFER(json_tokener_free(tok));

  json_object* object = json_tokener_parse_ex(tok, text, -1);
  DS_REQUIRE(object, json_tokener_error_desc(json_tokener_get_error(tok)));
  DS_DEFER(json_object_put(object));

  Args out;
  out.setJson(object);
  return out;
}

std::ostream& operator<<(std::ostream& ostream, const Args& x) {
  JSONWriter json(JSONWriter::jsonNoneResult);
  x.addFieldsToJson(json);
  return ostream << json.successJSON();
}

ds::Enum<Value_InputType> dsEnum(Value_InputType) {
  static constexpr std::pair<Value_InputType, const char *> x[] = {
    {Value_InputType::PUSH_BUTTON, "pushButton"},
    {Value_InputType::STATE, "state"},
  };
  return {gsl::make_span(x), "Value_InputType"};
}
std::ostream& operator<<(std::ostream& ostream, Value_InputType x) { return ds::ostream(ostream, x); }

ds::Enum<Value_Application> dsEnum(Value_Application) {
  static constexpr std::pair<Value_Application, const char*> x[] = {
      {Value_Application::LIGHTS, "lights"}, {Value_Application::BLINDS, "blinds"},
      {Value_Application::HEATING, "heating"}, {Value_Application::AUDIO, "audio"}, {Value_Application::VIDEO, "video"},
      {Value_Application::JOKER, "joker"}, {Value_Application::RECIRCULATION, "recirculation"},
      {Value_Application::SECURITY, "security"}, {Value_Application::ACCESS, "access"},
      {Value_Application::WINDOW, "window"}, {Value_Application::APARTMENT_VENTILATION, "apartmentVentilation"},
      {Value_Application::TEMPERATURE_CONTROL, "temperatureControl"}, {Value_Application::VENTILATION, "ventilation"},
      {Value_Application::AWNINGS, "awnings"},
  };
  return {gsl::make_span(x), "Value_Application"};
}
std::ostream& operator<<(std::ostream& ostream, Value_Application x) { return ds::ostream(ostream, x); }

ds::Enum<Value_PushButtonTarget> dsEnum(Value_PushButtonTarget) {
  static constexpr std::pair<Value_PushButtonTarget, const char *> x[] = {
    {Value_PushButtonTarget::DEVICE, "device"},
    {Value_PushButtonTarget::ZONE, "zone"},
    {Value_PushButtonTarget::AREA, "area"},
    {Value_PushButtonTarget::CLUSTER, "cluster"},
    {Value_PushButtonTarget::APP, "app"},
    {Value_PushButtonTarget::ALARM, "alarm"},
    {Value_PushButtonTarget::PANIC, "panic"},
    {Value_PushButtonTarget::LEAVING_HOME, "leavingHome"},
    {Value_PushButtonTarget::DOOR_BELL, "doorBell"},
    {Value_PushButtonTarget::DISABLED, "disabled"},
  };
  return {gsl::make_span(x), "Value_PushButtonTarget"};
}
std::ostream& operator<<(std::ostream& ostream, Value_PushButtonTarget x) { return ds::ostream(ostream, x); }

ds::Enum<Value_PushButtonTargetArea> dsEnum(Value_PushButtonTargetArea) {
  static constexpr std::pair<Value_PushButtonTargetArea, const char *> x[] = {
    {Value_PushButtonTargetArea::AREA1, "area1"},
    {Value_PushButtonTargetArea::AREA2, "area2"},
    {Value_PushButtonTargetArea::AREA3, "area3"},
    {Value_PushButtonTargetArea::AREA4, "area4"},
  };
  return {gsl::make_span(x), "Value_PushButtonTargetArea"};
}
std::ostream& operator<<(std::ostream& ostream, Value_PushButtonTargetArea x) { return ds::ostream(ostream, x); }

ds::Enum<Value_PushButtonTargetPresets> dsEnum(Value_PushButtonTargetPresets) {
  static constexpr std::pair<Value_PushButtonTargetPresets, const char *> x[] = {
    {Value_PushButtonTargetPresets::DEVICE_PRESETS2_TO4, "devicePresets2To4"},
    {Value_PushButtonTargetPresets::ZONE_PRESETS1_TO4, "zonePresets1To4"},
    {Value_PushButtonTargetPresets::ZONE_PRESETS10_TO14, "zonePresets10To14"},
    {Value_PushButtonTargetPresets::ZONE_PRESETS20_TO24, "zonePresets20To24"},
    {Value_PushButtonTargetPresets::ZONE_PRESETS30_TO34, "zonePresets30To34"},
    {Value_PushButtonTargetPresets::ZONE_PRESETS40_TO44, "zonePresets40To44"},
    {Value_PushButtonTargetPresets::AREA1_PRESETS1_TO4, "area1Presets1To4"},
    {Value_PushButtonTargetPresets::AREA2_PRESETS1_TO4, "area2Presets1To4"},
    {Value_PushButtonTargetPresets::AREA3_PRESETS1_TO4, "area3Presets1To4"},
    {Value_PushButtonTargetPresets::AREA4_PRESETS1_TO4, "area4Presets1To4"},
    {Value_PushButtonTargetPresets::AREA1_PRESETS12_TO14, "area1Presets12To14"},
    {Value_PushButtonTargetPresets::AREA2_PRESETS22_TO24, "area2Presets22To24"},
    {Value_PushButtonTargetPresets::AREA3_PRESETS32_TO34, "area3Presets32To34"},
    {Value_PushButtonTargetPresets::AREA4_PRESETS42_TO44, "area4Presets42To44"},
  };
  return {gsl::make_span(x), "Value_PushButtonTargetPresets"};
}
std::ostream& operator<<(std::ostream& ostream, Value_PushButtonTargetPresets x) { return ds::ostream(ostream, x); }

ds::Enum<Value_PushButtonMode> dsEnum(Value_PushButtonMode) {
  static constexpr std::pair<Value_PushButtonMode, const char *> x[] = {
    {Value_PushButtonMode::MODE1WAY, "mode1way"},
    {Value_PushButtonMode::MODE2WAY_DOWN, "mode2wayDown"},
    {Value_PushButtonMode::MODE2WAY_UP, "mode2wayUp"},
  };
  return {gsl::make_span(x), "Value_PushButtonMode"};
}
std::ostream& operator<<(std::ostream& ostream, Value_PushButtonMode x) { return ds::ostream(ostream, x); }

ds::Enum<Value_StateType> dsEnum(Value_StateType) {
  static constexpr std::pair<Value_StateType, const char *> x[] = {
    {Value_StateType::GENERIC, "generic"},
    {Value_StateType::PRESENCE, "presence"},
    {Value_StateType::TWILIGHT, "twilight"},
    {Value_StateType::MOTION, "motion"},
    {Value_StateType::SMOKE, "smoke"},
    {Value_StateType::WIND_STRENGTH_ABOVE_LIMIT, "windStrengthAboveLimit"},
    {Value_StateType::RAIN, "rain"},
    {Value_StateType::SUN_RADIATION, "sunRadiation"},
    {Value_StateType::SUN_PROTECTION, "sunProtection"},
    {Value_StateType::FROST, "frost"},
    {Value_StateType::TEMPERATURE_BELOW_LIMIT, "temperatureBelowLimit"},
    {Value_StateType::WINDOW_IS_OPEN, "windowIsOpen"},
    {Value_StateType::DOOR_IS_OPEN, "doorIsOpen"},
    {Value_StateType::GARAGE_DOOR_IS_OPEN, "garageDoorIsOpen"},
    {Value_StateType::HEATING_SYSTEM_ENABLED, "heatingSystemEnabled"},
    {Value_StateType::CHANGE_OVER_SIGNAL, "changeOverSignal"},
    {Value_StateType::MALFUNCTION, "malfunction"},
    {Value_StateType::SERVICE, "service"},
  };
  return {gsl::make_span(x), "Value_StateType"};
}
std::ostream& operator<<(std::ostream& ostream, Value_StateType x) { return ds::ostream(ostream, x); }

ds::Enum<Value_StateTarget> dsEnum(Value_StateTarget) {
  static constexpr std::pair<Value_StateTarget, const char *> x[] = {
    {Value_StateTarget::WHOLE_APARTMENT, "wholeApartment"},
    {Value_StateTarget::APARTMENT_VENTILATION, "apartmentVentilation"},
    {Value_StateTarget::VENTILATION, "ventilation"},
    {Value_StateTarget::RECIRCULATION, "recirculation"},
  };
  return {gsl::make_span(x), "Value_StateTarget"};
}
std::ostream& operator<<(std::ostream& ostream, Value_StateTarget x) { return ds::ostream(ostream, x); }

ds::Enum<Value_StateMode> dsEnum(Value_StateMode) {
  static constexpr std::pair<Value_StateMode, const char *> x[] = {
    {Value_StateMode::STANDARD, "standard"},
    {Value_StateMode::INVERTED, "inverted"},
    {Value_StateMode::RISING_EDGE1, "risingEdge1"},
    {Value_StateMode::FALLING_EDGE1, "fallingEdge1"},
    {Value_StateMode::RISING_EDGE0, "risingEdge0"},
    {Value_StateMode::FALLING_EDGE0, "fallingEdge0"},
    {Value_StateMode::TOGGLE_MODE_ON_RISING_EDGE, "toggleModeOnRisingEdge"},
    {Value_StateMode::TOGGLE_MODE_ON_FALLING_EDGE, "toggleModeOnFallingEdge"},
  };
  return {gsl::make_span(x), "Value_StateMode"};
}
std::ostream& operator<<(std::ostream& ostream, Value_StateMode x) { return ds::ostream(ostream, x); }

void Value::addFieldsToJson(::dss::JSONWriter& json) const {
  json.add("inputType");
  json.add(ds::tryFromEnum<const char *>(inputType).value_or("pushButton"));
  json.add("application");
  json.add(ds::tryFromEnum<const char *>(application).value_or("lights"));
  json.add("pushButtonTarget");
  json.add(ds::tryFromEnum<const char *>(pushButtonTarget).value_or("device"));
  json.add("pushButtonTargetArea");
  json.add(ds::tryFromEnum<const char *>(pushButtonTargetArea).value_or("area1"));
  json.add("pushButtonTargetClusterId");
  json.add(pushButtonTargetClusterId);
  json.add("pushButtonTargetPresets");
  json.add(ds::tryFromEnum<const char *>(pushButtonTargetPresets).value_or("devicePresets2To4"));
  json.add("pushButtonLocalPriorityFor1xClick");
  json.add(pushButtonLocalPriorityFor1xClick);
  json.add("pushButtonCallsPresent");
  json.add(pushButtonCallsPresent);
  json.add("pushButtonMode");
  json.add(ds::tryFromEnum<const char *>(pushButtonMode).value_or("mode1way"));
  json.add("stateType");
  json.add(ds::tryFromEnum<const char *>(stateType).value_or("generic"));
  json.add("stateTarget");
  json.add(ds::tryFromEnum<const char *>(stateTarget).value_or("wholeApartment"));
  json.add("stateMode");
  json.add(ds::tryFromEnum<const char *>(stateMode).value_or("standard"));
}

void Value::setJson(::json_object* object) {
  DS_REQUIRE(json_object_is_type(object, json_type_object), "Expecting json object.");
  json_object_object_foreach(object, dsCapnpKey, dsCapnpValue) {
  if (strcmp(dsCapnpKey, "inputType") == 0) {
    DS_CONTEXT("/inputType");
    DS_REQUIRE(json_object_is_type(dsCapnpValue, json_type_string), "Expecting json string");
    auto&& _dsCapnpStringValue = json_object_get_string(dsCapnpValue);
    if (auto x = ds::tryToEnum< ::dss::view::deviceConfig::dssCapnp::Value::InputType>(_dsCapnpStringValue)) {
      inputType = *x;
    } else {
      DS_FAIL_REQUIRE("Unrecognized enum value", _dsCapnpStringValue);
    }
  }
  if (strcmp(dsCapnpKey, "application") == 0) {
    DS_CONTEXT("/application");
    DS_REQUIRE(json_object_is_type(dsCapnpValue, json_type_string), "Expecting json string");
    auto&& _dsCapnpStringValue = json_object_get_string(dsCapnpValue);
    if (auto x = ds::tryToEnum< ::dss::view::deviceConfig::dssCapnp::Value::Application>(_dsCapnpStringValue)) {
      application = *x;
    } else {
      DS_FAIL_REQUIRE("Unrecognized enum value", _dsCapnpStringValue);
    }
  }
  if (strcmp(dsCapnpKey, "pushButtonTarget") == 0) {
    DS_CONTEXT("/pushButtonTarget");
    DS_REQUIRE(json_object_is_type(dsCapnpValue, json_type_string), "Expecting json string");
    auto&& _dsCapnpStringValue = json_object_get_string(dsCapnpValue);
    if (auto x = ds::tryToEnum< ::dss::view::deviceConfig::dssCapnp::Value::PushButtonTarget>(_dsCapnpStringValue)) {
      pushButtonTarget = *x;
    } else {
      DS_FAIL_REQUIRE("Unrecognized enum value", _dsCapnpStringValue);
    }
  }
  if (strcmp(dsCapnpKey, "pushButtonTargetArea") == 0) {
    DS_CONTEXT("/pushButtonTargetArea");
    DS_REQUIRE(json_object_is_type(dsCapnpValue, json_type_string), "Expecting json string");
    auto&& _dsCapnpStringValue = json_object_get_string(dsCapnpValue);
    if (auto x = ds::tryToEnum< ::dss::view::deviceConfig::dssCapnp::Value::PushButtonTargetArea>(_dsCapnpStringValue)) {
      pushButtonTargetArea = *x;
    } else {
      DS_FAIL_REQUIRE("Unrecognized enum value", _dsCapnpStringValue);
    }
  }
  if (strcmp(dsCapnpKey, "pushButtonTargetClusterId") == 0) {
    DS_CONTEXT("/pushButtonTargetClusterId");
    DS_REQUIRE(json_object_is_type(dsCapnpValue, json_type_double) ||
        json_object_is_type(dsCapnpValue, json_type_int), "Expecting json number");
    pushButtonTargetClusterId = json_object_get_int64(dsCapnpValue);
  }
  if (strcmp(dsCapnpKey, "pushButtonTargetPresets") == 0) {
    DS_CONTEXT("/pushButtonTargetPresets");
    DS_REQUIRE(json_object_is_type(dsCapnpValue, json_type_string), "Expecting json string");
    auto&& _dsCapnpStringValue = json_object_get_string(dsCapnpValue);
    if (auto x = ds::tryToEnum< ::dss::view::deviceConfig::dssCapnp::Value::PushButtonTargetPresets>(_dsCapnpStringValue)) {
      pushButtonTargetPresets = *x;
    } else {
      DS_FAIL_REQUIRE("Unrecognized enum value", _dsCapnpStringValue);
    }
  }
  if (strcmp(dsCapnpKey, "pushButtonLocalPriorityFor1xClick") == 0) {
    DS_CONTEXT("/pushButtonLocalPriorityFor1xClick");
    DS_REQUIRE(json_object_is_type(dsCapnpValue, json_type_boolean), "Expecting json boolean");
    pushButtonLocalPriorityFor1xClick = json_object_get_boolean(dsCapnpValue);
  }
  if (strcmp(dsCapnpKey, "pushButtonCallsPresent") == 0) {
    DS_CONTEXT("/pushButtonCallsPresent");
    DS_REQUIRE(json_object_is_type(dsCapnpValue, json_type_boolean), "Expecting json boolean");
    pushButtonCallsPresent = json_object_get_boolean(dsCapnpValue);
  }
  if (strcmp(dsCapnpKey, "pushButtonMode") == 0) {
    DS_CONTEXT("/pushButtonMode");
    DS_REQUIRE(json_object_is_type(dsCapnpValue, json_type_string), "Expecting json string");
    auto&& _dsCapnpStringValue = json_object_get_string(dsCapnpValue);
    if (auto x = ds::tryToEnum< ::dss::view::deviceConfig::dssCapnp::Value::PushButtonMode>(_dsCapnpStringValue)) {
      pushButtonMode = *x;
    } else {
      DS_FAIL_REQUIRE("Unrecognized enum value", _dsCapnpStringValue);
    }
  }
  if (strcmp(dsCapnpKey, "stateType") == 0) {
    DS_CONTEXT("/stateType");
    DS_REQUIRE(json_object_is_type(dsCapnpValue, json_type_string), "Expecting json string");
    auto&& _dsCapnpStringValue = json_object_get_string(dsCapnpValue);
    if (auto x = ds::tryToEnum< ::dss::view::deviceConfig::dssCapnp::Value::StateType>(_dsCapnpStringValue)) {
      stateType = *x;
    } else {
      DS_FAIL_REQUIRE("Unrecognized enum value", _dsCapnpStringValue);
    }
  }
  if (strcmp(dsCapnpKey, "stateTarget") == 0) {
    DS_CONTEXT("/stateTarget");
    DS_REQUIRE(json_object_is_type(dsCapnpValue, json_type_string), "Expecting json string");
    auto&& _dsCapnpStringValue = json_object_get_string(dsCapnpValue);
    if (auto x = ds::tryToEnum< ::dss::view::deviceConfig::dssCapnp::Value::StateTarget>(_dsCapnpStringValue)) {
      stateTarget = *x;
    } else {
      DS_FAIL_REQUIRE("Unrecognized enum value", _dsCapnpStringValue);
    }
  }
  if (strcmp(dsCapnpKey, "stateMode") == 0) {
    DS_CONTEXT("/stateMode");
    DS_REQUIRE(json_object_is_type(dsCapnpValue, json_type_string), "Expecting json string");
    auto&& _dsCapnpStringValue = json_object_get_string(dsCapnpValue);
    if (auto x = ds::tryToEnum< ::dss::view::deviceConfig::dssCapnp::Value::StateMode>(_dsCapnpStringValue)) {
      stateMode = *x;
    } else {
      DS_FAIL_REQUIRE("Unrecognized enum value", _dsCapnpStringValue);
    }
  }
  }
}

Value Value::fromJson(const char* text) {
  struct json_tokener* tok = json_tokener_new();
  DS_DEFER(json_tokener_free(tok));

  json_object* object = json_tokener_parse_ex(tok, text, -1);
  DS_REQUIRE(object, json_tokener_error_desc(json_tokener_get_error(tok)));
  DS_DEFER(json_object_put(object));

  Value out;
  out.setJson(object);
  return out;
}

std::ostream& operator<<(std::ostream& ostream, const Value& x) {
  JSONWriter json(JSONWriter::jsonNoneResult);
  x.addFieldsToJson(json);
  return ostream << json.successJSON();
}

void Data::addFieldsToJson(::dss::JSONWriter& json) const {
  json.add("args");
  json.startObject();
  args.addFieldsToJson(json);
  json.endObject();
  json.add("value");
  json.startObject();
  value.addFieldsToJson(json);
  json.endObject();
}

void Data::setJson(::json_object* object) {
  DS_REQUIRE(json_object_is_type(object, json_type_object), "Expecting json object.");
  json_object_object_foreach(object, dsCapnpKey, dsCapnpValue) {
  if (strcmp(dsCapnpKey, "args") == 0) {
    DS_CONTEXT("/args");
    args.setJson(dsCapnpValue);
  }
  if (strcmp(dsCapnpKey, "value") == 0) {
    DS_CONTEXT("/value");
    value.setJson(dsCapnpValue);
  }
  }
}

Data Data::fromJson(const char* text) {
  struct json_tokener* tok = json_tokener_new();
  DS_DEFER(json_tokener_free(tok));

  json_object* object = json_tokener_parse_ex(tok, text, -1);
  DS_REQUIRE(object, json_tokener_error_desc(json_tokener_get_error(tok)));
  DS_DEFER(json_object_put(object));

  Data out;
  out.setJson(object);
  return out;
}

std::ostream& operator<<(std::ostream& ostream, const Data& x) {
  JSONWriter json(JSONWriter::jsonNoneResult);
  x.addFieldsToJson(json);
  return ostream << json.successJSON();
}

}  // namespace
}  // namespace
}  // namespace
}  // namespace

