/*
    Copyright (c) 2017 digitalSTROM.org, Zurich, Switzerland

    This file is part of digitalSTROM Server.

    digitalSTROM Server is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    digitalSTROM Server is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with digitalSTROM Server. If not, see <http://www.gnu.org/licenses/>.
*/

#include <src/web/websocket/identifydevice.h>
#include "observerbuilder.h"

#include "ds/memory.h"


namespace dss {

namespace websocket {

std::unique_ptr<EventObserver> ObserverBuilder::build(
    const std::string& url, const std::string& method, const ds::JsonFragment& jsonFragment) const {
  if (url == "apartment/identifyDevices") {
    DS_REQUIRE(method.empty());
    (void) jsonFragment;
    return ds::make_unique<IdentifyDevice>();
  }

  DS_FAIL_REQUIRE("Can't find handler.", url);
};

} // namespace websocket

} // namespace dss
