#!/bin/bash

# Pulls vdc .po files from database

set -e

cd ${TOP_SRCDIR:-.}
. ./tx-env.sh

# pull vdc resources from database
for language in ${languages}; do
    dir=po/${language}
    mkdir -p ${dir}
    for gtin in ${gtins}; do
        echo -n ${gtin} ${language}
        file=${dir}/vdc-gtin-${gtin}.po
        wget --quiet -O${file} "http://db.aizo.net/dss-tx-gtin.php?gtin=${gtin}&langcode=${language}" && echo ": OK" || echo ": FAIL"
    done
    file=${dir}/vdc-common.po
    echo -n ${file} ${language}
    wget --quiet -O${file} "http://db.aizo.net/dss-tx-common.php?langcode=${language}" && echo ": OK" || echo ": FAIL"
done

# pull from transifex
if type "tx" > /dev/null; then
  tx pull -a
  tx pull --pseudo
fi
